curl --request POST \
--url https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key \
--header 'Authorization: <api-key>' \
--header 'Content-Type: multipart/form-data' \
--data-binary $'curl --request POST \'https://{base_url}/whatsapp/1/senders/{sender}/public-key\' \\\n--header \'Authorization: {authorization}\' \\\n--form \'file="@public_key.pem"\''import requests
url = "https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key"
headers = {
"Authorization": "<api-key>",
"Content-Type": "multipart/form-data"
}
response = requests.post(url, headers=headers)
print(response.text)using RestSharp;
var options = new RestClientOptions("https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key");
var client = new RestClient(options);
var request = new RestRequest("");
request.AlwaysMultipartFormData = true;
request.AddHeader("Authorization", "<api-key>");
var response = await client.PostAsync(request);
Console.WriteLine("{0}", response.Content);
HttpResponse<String> response = Unirest.post("https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key")
.header("Authorization", "<api-key>")
.header("Content-Type", "multipart/form-data")
.body("curl --request POST 'https://{base_url}/whatsapp/1/senders/{sender}/public-key' \\\n--header 'Authorization: {authorization}' \\\n--form 'file=\"@public_key.pem\"'")
.asString();<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => "curl --request POST 'https://{base_url}/whatsapp/1/senders/{sender}/public-key' \\\n--header 'Authorization: {authorization}' \\\n--form 'file=\"@public_key.pem\"'",
CURLOPT_HTTPHEADER => [
"Authorization: <api-key>",
"Content-Type: multipart/form-data"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}const options = {
method: 'POST',
headers: {Authorization: '<api-key>', 'Content-Type': 'multipart/form-data'}
};
fetch('https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));{
"errorCode": "E400",
"description": "Request cannot be processed.",
"action": "Check the syntax, violations and adjust the request.",
"violations": [
{
"property": "property.path",
"violation": "Violation message."
}
],
"resources": []
}{
"errorCode": "E401",
"description": "The request lacks valid authentication credentials for the requested resource.",
"action": "Check the resources and adjust authentication credentials.",
"violations": [],
"resources": [
{
"name": "API Authentication",
"url": "https://www.phonovation.com/docs/essentials/api-authentication"
}
]
}{
"errorCode": "E403",
"description": "Insufficient permissions to access the requested resource.",
"action": "Repeat the request with new or different credentials.",
"violations": [],
"resources": [
{
"name": "API Scopes",
"url": "https://www.phonovation.com/docs/essentials/api-essentials/api-authorization#api-scopes"
}
]
}{
"errorCode": "<string>",
"description": "<string>",
"action": "<string>",
"violations": [
{
"property": "<string>",
"violation": "<string>"
}
],
"resources": [
{
"name": "<string>",
"url": "<string>"
}
]
}{
"errorCode": "E429",
"description": "Too many requests sent.",
"action": "Check request rate limit specified in the API endpoint documentation resource.",
"violations": [],
"resources": [
{
"name": "Throttling handling errors",
"url": "https://www.phonovation.com/docs/essentials/integration-best-practices#throttling-handling-errors"
}
]
}{
"errorCode": "E500",
"description": "Something went wrong.",
"action": "Contact the support.",
"violations": [],
"resources": []
}Upload WhatsApp sender public key
Uploads a public key for WhatsApp encryption. The public key enables end-to-end encrypted data exchange with WhatsApp, such as in WhatsApp Flows. Previous keys are replaced when new ones are uploaded using this endpoint.
Required scope: Enable one of: whatsapp:manage.
curl --request POST \
--url https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key \
--header 'Authorization: <api-key>' \
--header 'Content-Type: multipart/form-data' \
--data-binary $'curl --request POST \'https://{base_url}/whatsapp/1/senders/{sender}/public-key\' \\\n--header \'Authorization: {authorization}\' \\\n--form \'file="@public_key.pem"\''import requests
url = "https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key"
headers = {
"Authorization": "<api-key>",
"Content-Type": "multipart/form-data"
}
response = requests.post(url, headers=headers)
print(response.text)using RestSharp;
var options = new RestClientOptions("https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key");
var client = new RestClient(options);
var request = new RestRequest("");
request.AlwaysMultipartFormData = true;
request.AddHeader("Authorization", "<api-key>");
var response = await client.PostAsync(request);
Console.WriteLine("{0}", response.Content);
HttpResponse<String> response = Unirest.post("https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key")
.header("Authorization", "<api-key>")
.header("Content-Type", "multipart/form-data")
.body("curl --request POST 'https://{base_url}/whatsapp/1/senders/{sender}/public-key' \\\n--header 'Authorization: {authorization}' \\\n--form 'file=\"@public_key.pem\"'")
.asString();<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => "curl --request POST 'https://{base_url}/whatsapp/1/senders/{sender}/public-key' \\\n--header 'Authorization: {authorization}' \\\n--form 'file=\"@public_key.pem\"'",
CURLOPT_HTTPHEADER => [
"Authorization: <api-key>",
"Content-Type: multipart/form-data"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}const options = {
method: 'POST',
headers: {Authorization: '<api-key>', 'Content-Type': 'multipart/form-data'}
};
fetch('https://api.messaging.phonovation.com/whatsapp/1/senders/{sender}/public-key', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));{
"errorCode": "E400",
"description": "Request cannot be processed.",
"action": "Check the syntax, violations and adjust the request.",
"violations": [
{
"property": "property.path",
"violation": "Violation message."
}
],
"resources": []
}{
"errorCode": "E401",
"description": "The request lacks valid authentication credentials for the requested resource.",
"action": "Check the resources and adjust authentication credentials.",
"violations": [],
"resources": [
{
"name": "API Authentication",
"url": "https://www.phonovation.com/docs/essentials/api-authentication"
}
]
}{
"errorCode": "E403",
"description": "Insufficient permissions to access the requested resource.",
"action": "Repeat the request with new or different credentials.",
"violations": [],
"resources": [
{
"name": "API Scopes",
"url": "https://www.phonovation.com/docs/essentials/api-essentials/api-authorization#api-scopes"
}
]
}{
"errorCode": "<string>",
"description": "<string>",
"action": "<string>",
"violations": [
{
"property": "<string>",
"violation": "<string>"
}
],
"resources": [
{
"name": "<string>",
"url": "<string>"
}
]
}{
"errorCode": "E429",
"description": "Too many requests sent.",
"action": "Check request rate limit specified in the API endpoint documentation resource.",
"violations": [],
"resources": [
{
"name": "Throttling handling errors",
"url": "https://www.phonovation.com/docs/essentials/integration-best-practices#throttling-handling-errors"
}
]
}{
"errorCode": "E500",
"description": "Something went wrong.",
"action": "Contact the support.",
"violations": [],
"resources": []
}Authorizations
This is the most secure authorization type and the one with the most flexibility.
API keys can be generated by calling the dedicated API method. Furthermore, API keys can have a limited scope and cover only some API methods. Lastly, they can be revoked at any time. This range of possibilities makes API keys well suited for separating the API access rights across multiple applications or use cases. Finally, the loss of an API key is easily manageable.
You can manage your API keys from GUI, or programmatically with dedicated API.
API key Authorization header example:
Authorization: App 003026bbc133714df1834b8638bb496e-8f4b3d9a-e931-478d-a994-28a725159ab9
Path Parameters
Registered WhatsApp sender number. Must be in international format.
1 - 15[0-9]+Body
Multipart form data containing the public key file. The file must be in PEM format with a 2048-bit RSA key and include the appropriate header and footer lines. Example file content: `----BEGIN PUBLIC KEY-----\n MIIBIjAN... \n ----END PUBLIC
Response
Public key uploaded successfully.